#! /usr/local/bin/perl
#==============================================================================
# $Id: MQService.pl,v 1.00 2001/04/27 15:10:46 Bobbee B $
#==============================================================================
#
#
#
#######################################################################################################################
#                                                                                                                     #
#                                                   MARSH NOTE                                                        #
#                                                                                                                     #
#######################################################################################################################
##                                                                                                                   ##
## Revision History:                                                                                                 ##
## Date								LABEL            Person           Comment                                                      ##
## ----               -----            ------           -------                                                      ##
## 11-09-2004         BB20041109       Bob Broderick    Removed Configmgr from Shutdown Exclusion                    ##
##                                                      Added Exclusion parameters for Startup/Shutdown              ##
##                                                      Added InClusion subroutine thus allowing of additional       ##
##                                                          resources that can be brought off/on line. Code has benn ##
##                                                          designed but not implemented. Can be used in the BROER   ##
##                                                          subroutine to replace the static off/on line declaration ##
##                                                                                                                   ##
####################################################################################################################### 
use English;
use File::Basename;
use strict;
use Win32::TieRegistry(Delimiter => "/") ;
require "ctime.pl";
use Getopt::Std;
#==============================================================================
my($top);
my $OutputDirectory    = 'D:\MQSeries_Backups' ;   
                            # <--- Output Directorye, SHOULD match WBIMB_PreBKUP.v001.pl
my $AUDITLOGdays=30 ;	  		# <--- Days to retain AUDITLOG file
my $ExclusionFile =  'D:\apps\SCRIPTS\WBIMB_Exclusion.txt' ;
														# <--- QMGR Exclusion file (Should have at least on blank line)
my $InClusionFile =  'D:\apps\SCRIPTS\WBIMB_InClusion.txt' ;
														# <--- MSCS Resource InClusion file. Non-MQ resources to be on & off lined.
														#      This has not been implemented yet/ Does not require attention
my $DEBUG='N' ;             # <--- DEBUG switch allows the input of MSCS output, normall retreived from issuing
                            #      a CLUSTER command, to be taken from a txt file. This is useful when debugging
                            #      the scripts on a non MSCS box and you would like to test the script in MSCS
                            #      mode. PCAnywhere to the MSCS serviced box where the QMGR and Broker are under
                            #      MSCS control and pipe the following commands output to the indicated file.
                            #				clusterstat.txt < cluster res stat
                            #       clusterPriv.txt < cluster res $MQGroup_Resource /priv
                            #				clustertype.txt	< cluster res /prop:type
                            #      Change $MQGroup_Resource to a Queue Manager resource group on the MSCS server
                            #      NOTE: The script will run against the files but eventualy will execute two WBI
                            #            supplied commands, dspmq and mqsilist, it will match the output of these
                            #            commands against the files in debug mode. Remember to change the references
                            #            to the broker and Queue Manager in the text files to match the names on the 
                            #            machine you are running on.
                            #      NOTE: Turning the DEBUG switch to "Y" will also prevent the script from executing
                            #            any MSCS or MQ or WBIMB commands. Print statements will indicate the actions
                            #            being taken.

my ($counter, $counter2, $counterB, $REScounter, $PRIVcounter, $TSTcounter, $IncCounter, $cluster_broker, $ending_value, $broker_ending_value, $testCTR, $amqmdainCMD, $ending_value, $QMGRS_ending_value) ;
my (@mqsilist, @ExclusionList, @InClusionList, @dspmqlist, @clustertxt, @broker, @cluster_broker, @EXPORT, @MQGroup_Resource, @clusterPrivtxt, @clustertype) ;
							
my($usage)      = join(''
                       , "usage: $0 \n"
                       , "\t[-t Request: u(p)/d(own)]\n"
                       , "\t[-e Environment: M(SCS)/n(oha)]\n"
                       ) ;
#
##
###    - Extract Queu Managers from the Registry
##
#

my $MQManager = $Registry->{'HKEY_LOCAL_MACHINE/SOFTWARE/IBM/MQSeries/CurrentVersion/Status/QueueManager/'};
my @KeyArray = keys %{$MQManager};

# delete output AUDITLOG file after AUDITLOGdays
#
if ( -e "$OutputDirectory\\MQService.log" ) {
	if ( -M "$OutputDirectory\\MQService.log" > $AUDITLOGdays) {
			system ("del $OutputDirectory\\MQService.log") ;
	}
}

open(AUDITLOG, ">>$OutputDirectory\\MQService.log" ) ;

my $runtime = localtime ;
print AUDITLOG "\n\n+ = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = + \n" ;
print AUDITLOG "+                                                                                           + \n" ;
print AUDITLOG "+                M Q S e r v i c e    $runtime                           + \n" ;
print AUDITLOG "+                                                                                           + \n" ;
print AUDITLOG "+ = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = + \n\n\n\n" ;
#
#					- Command Line Parsing routine

use vars qw($opt_t $opt_e);
#
# BB20041109
&getopts('t:e:') || die $usage ;
#		Read in the Exclusion file
&Read_EXCLUSION("read") ;
#		Read in the InClusion file
#&Read_EXCLUSION ;

print AUDITLOG " 0001 The following will be excluded from Startup/Shutdown\n" ;
print AUDITLOG " 0002 ", join("\n",@ExclusionList) ;
print AUDITLOG "\n 0003 End of Exclusion List\n" ; 


print AUDITLOG ' 0004 - Input arguments, Request = ',$opt_t,' Environment = ',$opt_e,"\n" ;

if ($opt_t =~ /u/i) {

#####################################################################################################################
##                                                                                                                 ##
##                                      S T A R T  MQ/WBIMB ENVIRONMENT                                            ##
##                                                                                                                 ##
#####################################################################################################################

		print AUDITLOG " 0005 **** Preparing to Start ($opt_t) the MQ / WBIMQ Services **** \n" ;
		$amqmdainCMD = 'start' ; 
		if ($opt_e =~ /m/i) {

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
#                                                                                                                   #
#                               Start the MQ/WBIMB in an MSCS_HA environment                                        #
#                                                                                                                   #
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
#
# First stop the Brokers in and out of MSCS, then stop the MSCS QMGRS, then stop remaining running QMGRS using endmqm 

				print AUDITLOG " 0006 **** Preparing to Start ($opt_t) the MQ / WBIMQ Services in the MSCS ($opt_e) environment**** \n" ;
				&Procees_ALL_Brokers ;
				&Procees_MSCS_QueueManagers ;
				&Procees_NonMSCS_QMGRS ;
			}
			else {
				if ($opt_e =~ /n/i) {

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
#                                                                                                                   #
#                               Start the MQ/WBIMB in an Non-MSCS_HA environment                                    #
#                                                                                                                   #
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
#
# First stop the Brokers, then stop the running Queue Managers using endmqm

					print AUDITLOG " 0007 **** Preparing to Start ($opt_t) the MQ / WBIMQ Services in the Non-MSCS ($opt_e) environment**** \n" ;
					&Procees_ALL_Brokers ;
					&Procees_NonMSCS_QMGRS ;
					}
					else {
						print AUDITLOG " 0008 Invalid Environment option for Start: $opt_e\n" ;
						print $usage ;
						exit 1 ;
					}
				}
			}
		else {
			if ($opt_t =~ /d/i) {
			
#####################################################################################################################
##                                                                                                                 ##
##                                       S T O P  MQ/WBIMB ENVIRONMENT                                             ##
##                                                                                                                 ##
#####################################################################################################################

				print AUDITLOG " 0009 **** Preparing to Stop ($opt_t) the MQ / WBIMQ Services **** \n" ;
				$amqmdainCMD = 'end' ; 
				if ($opt_e =~ /^m/i) {

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
#                                                                                                                   #
#                                Stop the MQ/WBIMB in an MSCS_HA environment                                        #
#                                                                                                                   #
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
#
# First we will stop the Brokers, then stop the MSCS Queue Managers, then stop remaining running QMGRS using endmqm

 					print AUDITLOG " 0010 **** Preparing to Stop ($opt_t) the MQ / WBIMQ Services in the MSCS ($opt_e) environment**** \n" ;
					&Procees_ALL_Brokers ;
					&Procees_MSCS_QueueManagers ;
					&Procees_NonMSCS_QMGRS ;
					}
					else {
						if ($opt_e =~ /n/i) {

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
#                                                                                                                   #
#                                Stop the MQ/WBIMB in an Non-MSCS_HA environment                                    #
#                                                                                                                   #
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
#
# First stop the Brokers, then stop all the running Queue Managers using endmqm

 							print AUDITLOG " 0011 **** Preparing to Stop ($opt_t) the MQ / WBIMQ Services in the Non-MSCS ($opt_e) environment**** \n" ;
 							&Procees_ALL_Brokers ;
							&Procees_NonMSCS_QMGRS ;
							}
							else {
								print AUDITLOG " 0012 Invalid Environment option for Stop: $opt_e\n" ;
								print $usage ;
								exit 1 ;
							}
						}
				}
				else {
					print AUDITLOG " 0013 Invalid Request: $opt_t\n" ;
					print $usage ;
					exit 1 ;
				}
			}
exit 0 ;

########################################################################################################################
##                                                                                                                    ##
##                                             S U B R O U T I N E S                                                  ##
##                                                                                                                    ##
########################################################################################################################
                                                       
#
##
###		Process each Queue Manager in the Registry Either Stop or Start depending on the opt_t parameter
##
#

sub Procees_NonMSCS_QMGRS {
	foreach $MQManager (@KeyArray){
		my $QueueManagerIndex = index($MQManager, "/") ;
		my $QueueManager = substr($MQManager, 0, $QueueManagerIndex) ;
		my $CmdSvrStatusString = 'HKEY_LOCAL_MACHINE/SOFTWARE/IBM/MQSeries/CurrentVersion/Status/QueueManager/'.$MQManager.'QueueManagerStatus/CmdSvrStatus' ;
		my $CmdSvrValue = $Registry->{$CmdSvrStatusString} ;
		my $CurrentStatusString = 'HKEY_LOCAL_MACHINE/SOFTWARE/IBM/MQSeries/CurrentVersion/Status/QueueManager/'.$MQManager.'QueueManagerStatus/CurrentStatus' ;
		my $CurrentStatus = $Registry->{$CurrentStatusString} ;
		print AUDITLOG " 0014 CurrentStatus $CurrentStatus CmdSvrValue $CmdSvrValue of $QueueManager\n" ;
		
# If we asked for down and the QMGR is running, bring it down

		if ($amqmdainCMD eq 'end' && $CurrentStatus eq 'Running' && $CmdSvrValue eq 'Running') {
				print AUDITLOG " 0015 **** Queue Manager $QueueManager is a Candidate **** \n" ;
#
# BB20041109
				if (!&Read_EXCLUSION("Test",$QueueManager)) {
						print AUDITLOG " 0016 **** $amqmdainCMD Queue Manager $QueueManager **** \n" ;
						if ($DEBUG !~ /y/i) {
								if (system ("endmqm $QueueManager") == 0 ) {
										print AUDITLOG " 0017 Stop of the $QueueManager service is successful\n" ;
								} else {
									print AUDITLOG " 0018 Stop of the $QueueManager was not successful\n" ;
									print AUDITLOG " 0019 Retun code from SYSTEM() call was $?\n" ;
									exit 1 ;
									}
						}
					

# We loop for a period of time to see if the QMGR cam down as we asked					

						$testCTR = 1 ;
						do {
							$CmdSvrValue = $Registry->{$CmdSvrStatusString} ;
							print AUDITLOG " 0020 **** $QueueManager check No $testCTR **** \n" ;
							$testCTR++ ;
							sleep 10 ;
						} until ($CmdSvrValue eq 'Ended' || $testCTR > 6) ;

# If the queue manager has not come down we will want to force it down
				
						if ($CmdSvrValue ne 'Ended') {	
#
# BB20041109
								print AUDITLOG " 0021 **** Forcing $QueueManager down **** \n" ;
								if ($DEBUG !~ /y/i) {
										system ("endmqm -i $QueueManager") ;
										sleep 40 ;
										system ("endmqlsr -m $QueueManager") ;
								} 
						} else {
								if ($DEBUG !~ /y/i) {
							 			system ("endmqlsr -m $QueueManager") ;
							 	}
							}
				}
		} else {					
# If we asked for up and the QMGR is down, bring it up
#
# BB20041109
				if (!&Read_EXCLUSION("Test", $QueueManager)) {
				 		if ($amqmdainCMD eq 'start' && $CmdSvrValue eq 'Ended') {
								print AUDITLOG " 0022 **** $amqmdainCMD Queue Manager $QueueManager **** \n" ;
						 		if ($DEBUG !~ /y/i) {
										if (system ("amqmdain $amqmdainCMD $QueueManager") == 0 ) {
												print AUDITLOG " 0023 Start of the $QueueManager service is successful\n" ;
										} else {
												print AUDITLOG " 0024 Start of the $QueueManager was not successful\n" ;
												print AUDITLOG " 0025 Retun code from SYSTEM() call was $?\n" ;
												exit 1 ;
											}
								}
						}	else {
								print AUDITLOG " 0026 QMGR not running and stop attemted or is running and a start was attempted **** \n" ;
			  			}
			  }
			}
		}
}

#
##
###		This routine will start/stop all the brokers in or out of MSCS
##
#

sub Procees_ALL_Brokers {

#
#    - go through the mqsilist command and find the brokers that are on the system
#

						my @mqsilist = `mqsilist` ;
						my $ending_value = scalar(@mqsilist) ;
						print AUDITLOG (" 0027 number of values in the mqsilist Array = ", $ending_value,"\n") ;
						$counter2 = 0 ;
						for($counter=0 ; $counter < $ending_value ; $counter++) {
#
#		
# BB20041109 removed ConfigMgr from exclusion so as to shut down Configmgr
#
							if ($mqsilist[$counter] !~ /nameserver/ && $mqsilist[$counter] =~ /BIP8099I/) {
								print AUDITLOG (" 0028 $mqsilist[$counter] is being used for the broker extraction\n") ;
								@EXPORT=split(/ +/, "$mqsilist[$counter]") ; 
								print AUDITLOG " 0029 ", join("\n",@EXPORT) ; 
								$broker[$counter2] = $EXPORT[1] ;
								print AUDITLOG (" 0030 Broker value = $broker[$counter2]\n") ;
								$counter2++;
							}
						}
						$counter2--;
						$broker_ending_value = scalar(@broker) ;
						print (AUDITLOG " 0031 Number of values in the Broker Array = ", $broker_ending_value,"\n") ;

#
#   Manually bring down CwDATAWAREConnector resource that has a dependency on JText which depends on MQSeries
#
						if ($opt_e =~ /m/i) {
								if ($opt_t =~ /d/i) {
										print AUDITLOG " 0032 Abount to take down MSCS Clustered resource CwDATAWAREConnector\n" ;
										if ($DEBUG !~ /y/i) {
												`cluster res CwDATAWAREConnector /off /wait:99` ;
										}
										else {
													print AUDITLOG (" 0033 TEST Execute cluster offline of CwDATAWAREConnector\n") ;
										}
								}
								else {
											print AUDITLOG " 0034 Abount to bring up MSCS Clustered resource CwDATAWAREConnector\n" ;
											if ($DEBUG !~ /y/i) {
													`cluster res CwDATAWAREConnector /on /wait:99` ;
											} 
											else {
														print AUDITLOG (" 0035 TEST Execute cluster online of CwDATAWAREConnector resource\n") ;
											}
								}
						}
							

# OK, do we have brokers in the array and which request are we processing inside or outside of MSCS??

						if (($broker_ending_value > 0) && ($opt_e =~ /m/i)) {
							
#
#    - go through the display cluster list and find if the brokers found are under MSCS
#

								&Read_Cluster_Output ;
								$ending_value = scalar(@clustertxt) ;
								print AUDITLOG (" 0036 number of values in the clustertxt Array = ", $ending_value,"\n") ;
								$counter2 = 1 ;

#
#    - go through the cluster stat output and offline the MSCS Brokers otherwise mqsistop them
#

								for($counterB=0 ; $counterB < $broker_ending_value ; $counterB++) {
#
# BB20041109
									if (!&Read_EXCLUSION("Test", $broker[$counterB])) {
											$cluster_broker = 'no' ;
											for($counter=4 ; $counter < $ending_value ; $counter++) {
												print AUDITLOG " 0037 Cluster text = $clustertxt[$counter] Broker text = $broker[$counterB]\n" ;
												if (($clustertxt[$counter] =~ /$broker[$counterB]/i) && ($clustertxt[$counter] =~ /MQSeriesBroker/i)) {
														@EXPORT=split(/ +/, "$clustertxt[$counter]") ;
														print AUDITLOG " 0038 ", join("\n", @EXPORT) ;
														$cluster_broker = $EXPORT[0] ;
														print AUDITLOG " 0039 Abount to process MSCS Clustered Broker $cluster_broker\n" ;
          		              if ($opt_t =~ /d/i) {
              		          	print AUDITLOG " 0040 About to take down MSCS Clustered Broker $cluster_broker\n" ;
                  		      	if ($DEBUG !~ /y/i) {
                      		  		`cluster res $cluster_broker /off /wait:99` ;
           		             		}
              		          	else {
                  		      			print AUDITLOG (" 0041 TEST Execute cluster offline of $cluster_broker\n") ;
                      		  	}
           		             } else {
                  		      		print AUDITLOG " 0042 About to bring up MSCS Clustered Broker $cluster_broker\n" ;
                      		  		if ($DEBUG !~ /y/i) {
                        						`cluster res $cluster_broker /on /wait:99` ;
      		                  		}
          		              }
													}
											}
#											***************************************
											if ($cluster_broker =~ /no/) {
													if ($opt_t =~ /d/i) {
															print AUDITLOG " 0043 Not under MQSC. Taking down $broker[$counterB] using mqsistop command\n" ;
															if ($DEBUG !~ /y/i) {
																	`mqsistop $broker[$counterB]` ;
															} else {
																	print AUDITLOG (" 0041.5 TEST Execute mqsistop of $cluster_broker\n") ;
																}
													} else {
															print AUDITLOG " 0043 Not under MQSC. Starting $broker[$counterB] using mqsistart command\n" ;
															if ($DEBUG !~ /y/i) {
																	`mqsistart $broker[$counterB]` ;
															} else {
																	print AUDITLOG (" 0041.6 TEST Execute mqsistop of $cluster_broker\n") ;
																}
													}
											} # end of 'no'
#											****************************************
										}
								} 
						}
# We ended up here because we are ending brokers and the request is for Non-MSCS, lets check we have brokers
						else {
									if ($broker_ending_value > 0) {
										for($counterB=0 ; $counterB < $broker_ending_value ; $counterB++) {
											print AUDITLOG (" 0044 Broker not under MQSC. Taking down $broker[$counterB] using mqsistop command\n") ;
#
# BB20041109
											if (!&Read_EXCLUSION("Test", $broker[$counterB])) {
#                     *****************************************
													if ($opt_t =~ /d/i) {
															if ($DEBUG !~ /y/i) {
																	`mqsistop $broker[$counterB]` ;
															} else {
																	print AUDITLOG (" 0044.5 TEST Execute mqsistop of $cluster_broker\n") ;
																}
													} else {
															if ($DEBUG !~ /y/i) {
																	`mqsistart $broker[$counterB]` ;
															} else {
																	print AUDITLOG (" 0044.6 TEST Execute mqsistart of $cluster_broker\n") ;
																}
														}
#                     *****************************************
											} # Read EXCLUSION
										}
									} else {
										print AUDITLOG (" 0045 001 No Brokers to bring down. broker_ending_value = $broker_ending_value\n") ;
										}
						}
											
}

#
##
###		This routine will stop/start all the QMGRS on the server under MSCS control
##
#

sub Procees_MSCS_QueueManagers {
	
#
#    - go through the display cluster list and find if the brokers found are under MSCS
#

						&Read_ClusterType_Output ;
						$ending_value = scalar(@clustertype) ;
						print AUDITLOG (" 0046 number of values in the clustertype.txt Array = ", $ending_value,"\n") ;
						print AUDITLOG " 0047 ", join("\n",@clustertype) ;
						$counter2 = 0 ;
						
						
						for($counter=0 ; $counter < $ending_value ; $counter++) {
							if ($clustertype[$counter] =~ /IBM MQSeries MSCS/) {
								print AUDITLOG " 0048 $clustertype[$counter] is being used for the Queue Manager extraction\n" ;
								@EXPORT=split(/ +/, $clustertype[$counter]) ; 
								print AUDITLOG " 0049 ", join("\n",@EXPORT) ; 
								$MQGroup_Resource[$counter2] = $EXPORT[1] ;
								print AUDITLOG " 0050 Queue Manager value = $MQGroup_Resource[$counter2]\n" ;
								$counter2++;
							}
						}
						$counter2--;
						print AUDITLOG " 0051 Number of values in counter2 = $counter2\n " ;
						print AUDITLOG " 0052 Number of values in counter2 = $counter2\n " ;

#
#    - go through the display CLUSTER RES $MQGroup_Resource[$counter2] /PRIV list and extract QMGR name
#
					
						for($REScounter=0 ; !($REScounter > $counter2) ; $REScounter++) {
							print AUDITLOG (" 0053 Value of MQGroup_Resource[REScounter] = $MQGroup_Resource[$REScounter]\n") ;
							&Read_Cluster_PRIV_Output ;
							print AUDITLOG (" 0054 Number of values in the clusterPrivtxt Array = ", scalar(@clusterPrivtxt),"\n") ;
							print AUDITLOG " 0055 ", join("\n",@clusterPrivtxt) ;
							for($PRIVcounter=0 ; $PRIVcounter < scalar(@clusterPrivtxt) ; $PRIVcounter++) {
								if ($clusterPrivtxt[$PRIVcounter] =~ /QueueManagerName/) {
										print AUDITLOG (" 0056 $clusterPrivtxt[$PRIVcounter] is being used for the Queue Manager extraction\n") ;
										print AUDITLOG (" 0057 $MQGroup_Resource[$REScounter] is being used for the Queue Manager RESOURCE\n") ;
										@EXPORT=split(/ +/, "$clusterPrivtxt[$PRIVcounter]") ;
										print AUDITLOG " 0058 ", join("\n",@EXPORT) ;
#
# BB20041109
                 		print AUDITLOG " 0059 About to test Queue Manager $EXPORT[3] \n" ;
										if (!&Read_EXCLUSION("Test", $EXPORT[3])) {
												if ($opt_t =~ /d/i) {
														print AUDITLOG " 0060 About to take offline Queue Manager $EXPORT[3] \n" ;
														if ($DEBUG !~ /y/i) {
																`cluster res $MQGroup_Resource[$REScounter] /off /wait:99` ;
                  					}	else {
            		      						print AUDITLOG " 0061 Test mode execute of QMGR offline command for $MQGroup_Resource[$REScounter] \n" ;
                		  			}
                  			}			
												else {
														print AUDITLOG " 0062 About to put Queue Manager $EXPORT[3] on line \n" ;
														if ($DEBUG !~ /y/i) {
																`cluster res $MQGroup_Resource[$REScounter] /on /wait:99` ;
														} else {
             		     							print AUDITLOG " 0063 Test mode execute of QMGR online command for $MQGroup_Resource[$REScounter] \n" ;
                		  			}
												} 
										}
										$PRIVcounter = scalar(@clusterPrivtxt) ;
										print AUDITLOG " 0064 Have processed the Queue Manager $EXPORT[0] \n" ;
								}
							}
						}
						print AUDITLOG " 0065 Number of values in counter2 = $counter2\n" ; 
}


#
##
###   Routine will load the CLUSTER RES /STAT output either from a file or cmd depending on DEBUG setting
##
#

sub Read_Cluster_Output {
	if ($DEBUG =~ /y/i) {
# open file
			print AUDITLOG " 0066 Opening clusterstat.txt file\n" ;
			open(FILE, "clusterstat.txt") or die("Unable to open file") ;
# read file into an array
			print AUDITLOG " 0067 Opening clusterstat.txt file\n" ;
			@clustertxt = <FILE> ;
# close file
			print AUDITLOG " 0068 Opening clusterstat.txt file\n" ;
			close(FILE) ;
	}
	else {
				@clustertxt = `cluster res` ;
	}
	print AUDITLOG (" 0069 Value of clustertxt = ") ; 
	print AUDITLOG join("\n",@clustertxt) ;
}
			

#
##
###		Routine will load the CLUSTER RES QMGR_Resource /stat output either from a file or cmd depending on DEBUG setting
##
#

sub Read_Cluster_PRIV_Output {
	if ($DEBUG =~ /y/i) {
# open file
			print AUDITLOG " 0071 Opening clusterPriv.txt file\n" ;
			open(FILE, "clusterPriv.txt") or die("Unable to open file") ;
# read file into an array
			print AUDITLOG " 0072 Reading clusterPriv.txt file\n" ;
			@clusterPrivtxt = <FILE> ;
# close file 
			print AUDITLOG " 0073 Closing clusterPriv.txt file\n" ;
			close(FILE) ;
	}
	else {
				@clusterPrivtxt = `cluster res $MQGroup_Resource[$REScounter] /priv` ;
	}
	print AUDITLOG (" 0074 Value of MQGroup_Resource[REScounter] = $MQGroup_Resource[$REScounter]\n") ;
	print AUDITLOG (" 0075 Value of clusterPrivtxt = ") ; 
	print AUDITLOG " 0076 ", join("\n",@clusterPrivtxt) ;
}

#
##
###		Routine will load the CLUSTER RES /prop:type output either from a file or cmd depending on DEBUG setting
##
#

sub Read_ClusterType_Output {
	if ($DEBUG =~ /y/i) {
# open file
			print AUDITLOG " 0077 Opening clustertype.txt file\n" ;
			open(FILE, "clustertype.txt") or die("Unable to open file") ;
# read file into an array
			print AUDITLOG " 0078 Opening clustertype.txt file\n" ;
			@clustertype = <FILE> ;
# close file
			print AUDITLOG " 0079 Opening clustertype.txt file\n" ;
			close(FILE) ;
	}
	else {
			@clustertype = `cluster res /prop:type` ;
	}
	print AUDITLOG (" 0080 Value of clustertype = \n") ; 
	print AUDITLOG " 0081", join("\n",@clustertype) ;
	print "\n" ;
}


#
# BB20041109
#
##
###		Load the Exclusion List. File contains Brokers and Queue Managers that should not be processed.
##
#

sub Read_EXCLUSION {
	
# retrieve the argument
	if ($_[0] eq 'Test') {
		for($TSTcounter=0 ; $TSTcounter < scalar(@ExclusionList) ; $TSTcounter++) {
			if ($ExclusionList[$TSTcounter] =~ /$_[1]/i) {
				return 1 ;
			}
		}
		return 0 ;
	} else {
		if (-e  $ExclusionFile) {
# open file
#		    print AUDITLOG " 0082 Opening WBIMB_Exclusion.txt file\n" ;
				open(FILE, $ExclusionFile) or die("Unable to open file") ;
# read file into an array
#		    print AUDITLOG " 0083 Reading WBIMB_Exclusion.txt file\n" ;
				@ExclusionList = <FILE> ;
# Remove Leading and Trailing spaces
				for($TSTcounter=0 ; $TSTcounter < scalar(@ExclusionList) ; $TSTcounter++) {
					$ExclusionList[$TSTcounter] =~ s/^\s+//;
					$ExclusionList[$TSTcounter] =~ s/\s+$//;
				}

# close file
#		    print AUDITLOG " 0084 Closing WBIMB_Exclusion.txt file\n" ;
				close(FILE) ;
#				print AUDITLOG " 0085 The following will be excluded from Startup/Shutdown\n" ;
#				print AUDITLOG " 0086 ", join("\n",@ExclusionList) ;
#				print AUDITLOG "\n 0087 End of LIST\n" ; 
			} else {
				print AUDITLOG " 0088 File WBIMB_Exclusion.txt does not exist\n" ;
				@ExclusionList = '        ' ;
				}
	}
}


#
# BB20041109
#
##
###		Load the InClusion List. File contains MSCS items to additionally bring offline.
##
#

sub Read_INCLUSION {
	
		if (-e  $InClusionFile) {
# open file
#		    print AUDITLOG " 0089 Opening WBIMB_InClusion.txt file\n" ;
				open(FILE, $InClusionFile) or die("Unable to open file") ;
# read file into an array
#		    print AUDITLOG " 0090 Reading WBIMB_InClusion.txt file\n" ;
				@InClusionList = <FILE> ;
# Remove Leading and Trailing spaces
				for($IncCounter=0 ; $IncCounter <= scalar(@InClusionList) ; $IncCounter++) {
					$InClusionList[$IncCounter] =~ s/^\s+//;
					$InClusionList[$IncCounter] =~ s/\s+$//;
				}

# close file
#		    print AUDITLOG " 0091 Closing WBIMB_InClusion.txt file\n" ;
				close(FILE) ;
#				print AUDITLOG " 0092 The following will be included from Startup/Shutdown\n" ;
#				print AUDITLOG " 0093 ", join("\n",@InClusionList) ;
#				print AUDITLOG "\n 0094 End of LIST\n" ; 
			} else {
				print AUDITLOG " 0095 File WBIMB_InClusion.txt does not exist\n" ;
				@InClusionList = 'noname' ;
				}
}

########################################################################################################################
##                                                                                                                    ##
##                       M S C S    C L U S T E R    T E S T    I N P U T   E X A M P L E S                           ##
##                                                                                                                    ##
########################################################################################################################

#
##
###		Example of the clusterstat.txt file
##
#

#Listing status for all available resources:
#
#Resource             Group                Node            Status
#-------------------- -------------------- --------------- ------
#Cluster IP Address   Cluster Group        USDEMAS43       Online
#Cluster Name         Cluster Group        USDEMAS43       Online
#Disk Q:              Cluster Group        USDEMAS43       Online
#Disk P:              MQ Group             USDEMAS42       Online
#MQ IP Address        MQ Group             USDEMAS42       Online
#USDEMVS11            MQ Group             USDEMAS42       Online
#DEM042S2             MQ Group             USDEMAS42       Online
#MQSeriesBrokerDEM042S2BRK MQ Group             USDEMAS42       Online
#MQSeriesBrokerWBIMBBRK MQ Group             USDEMAS42       Online
#DEM042S3             MQ Group             USDEMAS42       Online
#var                  MQ Group             USDEMAS42       Online
#DATAWARE             MQ Group             USDEMAS42       Online

#
##
###		Example of the clusterPriv.txt file
##
#

#
#Listing private properties for DEM042S3:
#
#T  Resource             Name                           Value
#-- -------------------- ------------------------------ -----------------------
#S  DEM042S3             QueueManagerName               DEM042S3
#S  DEM042S3             PostOnlineCommand              
#S  DEM042S3             PreOfflineCommand              
#S  DEM042S3             ExtraChkptKeys     

#
##
###		Example of the clustertype.txt file
##
#

#Listing properties for all resources:
#
#T  Resource             Name                           Value
#-- -------------------- ------------------------------ -----------------------
#S  Cluster IP Address   Type                           IP Address
#S  Cluster Name         Type                           Network Name
#S  Disk Q:              Type                           Physical Disk
#S  CwDATAWAREConnector  Type                           Generic Service
#S  Disk P:              Type                           Physical Disk
#S  MQ IP Address        Type                           IP Address
#S  USDEMVS11            Type                           Network Name
#S  DEM042S2             Type                           IBM MQSeries MSCS
#S  MQSeriesBrokerDEM042S2BRK Type                           Generic Service
#S  DEM042S3             Type                           IBM MQSeries MSCS
#S  var                  Type                           File Share
#S  DATAWARE             Type                           File Share